﻿// discussion: 
// http://forum.rudtp.ru/showthread.php?t=53290

d = app.activeDocument;
dName = d.name.split('.')[0];

mapLayers = function(func){
	var i, rv = [], a = d.layers;

	for (i = a.length; i --> 0;) rv[i] = func(a[i], i);
	
	return rv;
}

// save layers visibility
states = mapLayers(function(l){return l.visible});

mapLayers(function(l, i){
	// show one layer
	mapLayers(function(l, j){l.visible = i == j});
	
	var f = new File(Folder.desktop.absoluteURI + 
		'/' + File.encode(l.name + '_' + dName));
	
	d.exportFile(f, ExportType.SVG);
});

// restore layers visibility
mapLayers(function(l, i){l.visible = states[i]});
